rc.subr revision 179872
1# $NetBSD: rc.subr,v 1.67 2006/10/07 11:25:15 elad Exp $
2# $FreeBSD: head/etc/rc.subr 179872 2008-06-19 07:06:11Z mtm $
3#
4# Copyright (c) 1997-2004 The NetBSD Foundation, Inc.
5# All rights reserved.
6#
7# This code is derived from software contributed to The NetBSD Foundation
8# by Luke Mewburn.
9#
10# Redistribution and use in source and binary forms, with or without
11# modification, are permitted provided that the following conditions
12# are met:
13# 1. Redistributions of source code must retain the above copyright
14#    notice, this list of conditions and the following disclaimer.
15# 2. Redistributions in binary form must reproduce the above copyright
16#    notice, this list of conditions and the following disclaimer in the
17#    documentation and/or other materials provided with the distribution.
18# 3. All advertising materials mentioning features or use of this software
19#    must display the following acknowledgement:
20#        This product includes software developed by the NetBSD
21#        Foundation, Inc. and its contributors.
22# 4. Neither the name of The NetBSD Foundation nor the names of its
23#    contributors may be used to endorse or promote products derived
24#    from this software without specific prior written permission.
25#
26# THIS SOFTWARE IS PROVIDED BY THE NETBSD FOUNDATION, INC. AND CONTRIBUTORS
27# ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED
28# TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
29# PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL THE FOUNDATION OR CONTRIBUTORS
30# BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
31# CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
32# SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
33# INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
34# CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
35# ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
36# POSSIBILITY OF SUCH DAMAGE.
37#
38# rc.subr
39#	functions used by various rc scripts
40#
41
42: ${rcvar_manpage:='rc.conf(5)'}
43: ${RC_PID:=$$}; export RC_PID
44
45#
46#	Operating System dependent/independent variables
47#
48
49if [ -z "${_rc_subr_loaded}" ]; then
50
51_rc_subr_loaded="YES"
52
53SYSCTL="/sbin/sysctl"
54SYSCTL_N="${SYSCTL} -n"
55CMD_OSTYPE="${SYSCTL_N} kern.ostype"
56OSTYPE=`${CMD_OSTYPE}`
57ID="/usr/bin/id"
58IDCMD="if [ -x $ID ]; then $ID -un; fi"
59PS="/bin/ps -ww"
60JID=`$PS -p $$ -o jid=`
61
62case ${OSTYPE} in
63FreeBSD)
64	SYSCTL_W="${SYSCTL}"
65	;;
66NetBSD)
67	SYSCTL_W="${SYSCTL} -w"
68	;;
69esac
70
71#
72#	functions
73#	---------
74
75#
76# set_rcvar base_var
77#	Set the variable name enabling a specific service.
78#	FreeBSD uses ${service}_enable, while NetBSD uses
79#	just the name of the service. For example:
80#	FreeBSD: sendmail_enable="YES"
81#	NetBSD : sendmail="YES"
82#	$1 - if $name is not the base to work of off, specify
83#	     a different one
84#
85set_rcvar()
86{
87	if [ -z "$1" ]; then
88		base_var=${name}
89	else
90		base_var="$1"
91	fi
92
93	case ${OSTYPE} in
94	FreeBSD)
95		echo ${base_var}_enable
96		;;
97	NetBSD)
98		echo ${base_var}
99		;;
100	*)
101		echo 'XXX'
102		;;
103	esac
104}
105
106#
107# force_depend script
108#	Force a service to start. Intended for use by services
109#	to resolve dependency issues. It is assumed the caller
110#	has check to make sure this call is necessary
111#	$1 - filename of script, in /etc/rc.d, to run
112#
113force_depend()
114{
115	_depend="$1"
116
117	info "${name} depends on ${_depend}, which will be forced to start."
118	if ! /etc/rc.d/${_depend} forcestart; then
119		warn "Unable to force ${_depend}. It may already be running."
120		return 1
121	fi
122	return 0
123}
124
125#
126# checkyesno var
127#	Test $1 variable, and warn if not set to YES or NO.
128#	Return 0 if it's "yes" (et al), nonzero otherwise.
129#
130checkyesno()
131{
132	eval _value=\$${1}
133	debug "checkyesno: $1 is set to $_value."
134	case $_value in
135
136		#	"yes", "true", "on", or "1"
137	[Yy][Ee][Ss]|[Tt][Rr][Uu][Ee]|[Oo][Nn]|1)
138		return 0
139		;;
140
141		#	"no", "false", "off", or "0"
142	[Nn][Oo]|[Ff][Aa][Ll][Ss][Ee]|[Oo][Ff][Ff]|0)
143		return 1
144		;;
145	*)
146		warn "\$${1} is not set properly - see ${rcvar_manpage}."
147		return 1
148		;;
149	esac
150}
151
152#
153# reverse_list list
154#	print the list in reverse order
155#
156reverse_list()
157{
158	_revlist=
159	for _revfile; do
160		_revlist="$_revfile $_revlist"
161	done
162	echo $_revlist
163}
164
165# stop_boot always
166#	If booting directly to multiuser or $always is enabled,
167#	send SIGTERM to the parent (/etc/rc) to abort the boot.
168#	Otherwise just exit.
169#
170stop_boot()
171{
172	local always
173
174	case $1 in
175		#	"yes", "true", "on", or "1"
176        [Yy][Ee][Ss]|[Tt][Rr][Uu][Ee]|[Oo][Nn]|1)
177		always=true
178		;;
179	*)
180		always=false
181		;;
182	esac
183	if [ "$autoboot" = yes -o "$always" = true ]; then
184		echo "ERROR: ABORTING BOOT (sending SIGTERM to parent)!"
185		kill -TERM ${RC_PID}
186	fi
187	exit 1
188}
189
190#
191# mount_critical_filesystems type
192#	Go through the list of critical filesystems as provided in
193#	the rc.conf(5) variable $critical_filesystems_${type}, checking
194#	each one to see if it is mounted, and if it is not, mounting it.
195#
196mount_critical_filesystems()
197{
198	eval _fslist=\$critical_filesystems_${1}
199	for _fs in $_fslist; do
200		mount | (
201			_ismounted=false
202			while read what _on on _type type; do
203				if [ $on = $_fs ]; then
204					_ismounted=true
205				fi
206			done
207			if $_ismounted; then
208				:
209			else
210				mount $_fs >/dev/null 2>&1
211			fi
212		)
213	done
214}
215
216#
217# check_pidfile pidfile procname [interpreter]
218#	Parses the first line of pidfile for a PID, and ensures
219#	that the process is running and matches procname.
220#	Prints the matching PID upon success, nothing otherwise.
221#	interpreter is optional; see _find_processes() for details.
222#
223check_pidfile()
224{
225	_pidfile=$1
226	_procname=$2
227	_interpreter=$3
228	if [ -z "$_pidfile" -o -z "$_procname" ]; then
229		err 3 'USAGE: check_pidfile pidfile procname [interpreter]'
230	fi
231	if [ ! -f $_pidfile ]; then
232		debug "pid file ($_pidfile): not readable."
233		return
234	fi
235	read _pid _junk < $_pidfile
236	if [ -z "$_pid" ]; then
237		debug "pid file ($_pidfile): no pid in file."
238		return
239	fi
240	_find_processes $_procname ${_interpreter:-.} '-p '"$_pid"
241}
242
243#
244# check_process procname [interpreter]
245#	Ensures that a process (or processes) named procname is running.
246#	Prints a list of matching PIDs.
247#	interpreter is optional; see _find_processes() for details.
248#
249check_process()
250{
251	_procname=$1
252	_interpreter=$2
253	if [ -z "$_procname" ]; then
254		err 3 'USAGE: check_process procname [interpreter]'
255	fi
256	_find_processes $_procname ${_interpreter:-.} '-ax'
257}
258
259#
260# _find_processes procname interpreter psargs
261#	Search for procname in the output of ps generated by psargs.
262#	Prints the PIDs of any matching processes, space separated.
263#
264#	If interpreter == ".", check the following variations of procname
265#	against the first word of each command:
266#		procname
267#		`basename procname`
268#		`basename procname` + ":"
269#		"(" + `basename procname` + ")"
270#		"[" + `basename procname` + "]"
271#
272#	If interpreter != ".", read the first line of procname, remove the
273#	leading #!, normalise whitespace, append procname, and attempt to
274#	match that against each command, either as is, or with extra words
275#	at the end.  As an alternative, to deal with interpreted daemons
276#	using perl, the basename of the interpreter plus a colon is also
277#	tried as the prefix to procname.
278#
279_find_processes()
280{
281	if [ $# -ne 3 ]; then
282		err 3 'USAGE: _find_processes procname interpreter psargs'
283	fi
284	_procname=$1
285	_interpreter=$2
286	_psargs=$3
287
288	_pref=
289	if [ $_interpreter != "." ]; then	# an interpreted script
290		_script=${_chroot}${_chroot:+"/"}$_procname
291		if [ -r $_script ]; then
292			read _interp < $_script	# read interpreter name
293			case "$_interp" in
294			\#!*)
295				_interp=${_interp#\#!}	# strip #!
296				set -- $_interp
297				case $1 in
298				*/bin/env)
299					shift	# drop env to get real name
300					;;
301				esac
302				if [ $_interpreter != $1 ]; then
303					warn "\$command_interpreter $_interpreter != $1"
304				fi
305				;;
306			*)
307				warn "no shebang line in $_script"
308				set -- $_interpreter
309				;;
310			esac
311		else
312			warn "cannot read shebang line from $_script"
313			set -- $_interpreter
314		fi
315		_interp="$* $_procname"		# cleanup spaces, add _procname
316		_interpbn=${1##*/}
317		_fp_args='_argv'
318		_fp_match='case "$_argv" in
319		    ${_interp}|"${_interp} "*|"${_interpbn}: ${_procname}"*)'
320	else					# a normal daemon
321		_procnamebn=${_procname##*/}
322		_fp_args='_arg0 _argv'
323		_fp_match='case "$_arg0" in
324		    $_procname|$_procnamebn|${_procnamebn}:|"(${_procnamebn})"|"[${_procnamebn}]")'
325	fi
326
327	_proccheck="\
328		$PS 2>/dev/null -o pid= -o jid= -o command= $_psargs"' |
329		while read _npid _jid '"$_fp_args"'; do
330			'"$_fp_match"'
331				if [ "$JID" -eq "$_jid" ];
332				then echo -n "$_pref$_npid";
333				_pref=" ";
334				fi
335				;;
336			esac
337		done'
338
339#	debug "in _find_processes: proccheck is ($_proccheck)."
340	eval $_proccheck
341}
342
343#
344# wait_for_pids pid [pid ...]
345#	spins until none of the pids exist
346#
347wait_for_pids()
348{
349	_list="$@"
350	if [ -z "$_list" ]; then
351		return
352	fi
353	_prefix=
354	while true; do
355		_nlist="";
356		for _j in $_list; do
357			if kill -0 $_j 2>/dev/null; then
358				_nlist="${_nlist}${_nlist:+ }$_j"
359			fi
360		done
361		if [ -z "$_nlist" ]; then
362			break
363		fi
364		_list=$_nlist
365		echo -n ${_prefix:-"Waiting for PIDS: "}$_list
366		_prefix=", "
367		sleep 2
368	done
369	if [ -n "$_prefix" ]; then
370		echo "."
371	fi
372}
373
374#
375# run_rc_command argument
376#	Search for argument in the list of supported commands, which is:
377#		"start stop restart rcvar status poll ${extra_commands}"
378#	If there's a match, run ${argument}_cmd or the default method
379#	(see below).
380#
381#	If argument has a given prefix, then change the operation as follows:
382#		Prefix	Operation
383#		------	---------
384#		fast	Skip the pid check, and set rc_fast=yes, rc_quiet=yes
385#		force	Set ${rcvar} to YES, and set rc_force=yes
386#		one	Set ${rcvar} to YES
387#		quiet	Don't output some diagnostics, and set rc_quiet=yes
388#
389#	The following globals are used:
390#
391#	Name		Needed	Purpose
392#	----		------	-------
393#	name		y	Name of script.
394#
395#	command		n	Full path to command.
396#				Not needed if ${rc_arg}_cmd is set for
397#				each keyword.
398#
399#	command_args	n	Optional args/shell directives for command.
400#
401#	command_interpreter n	If not empty, command is interpreted, so
402#				call check_{pidfile,process}() appropriately.
403#
404#	extra_commands	n	List of extra commands supported.
405#
406#	pidfile		n	If set, use check_pidfile $pidfile $command,
407#				otherwise use check_process $command.
408#				In either case, only check if $command is set.
409#
410#	procname	n	Process name to check for instead of $command.
411#
412#	rcvar		n	This is checked with checkyesno to determine
413#				if the action should be run.
414#
415#	${name}_program	n	Full path to command.
416#				Meant to be used in /etc/rc.conf to override
417#				${command}.
418#
419#	${name}_chroot	n	Directory to chroot to before running ${command}
420#				Requires /usr to be mounted.
421#
422#	${name}_chdir	n	Directory to cd to before running ${command}
423#				(if not using ${name}_chroot).
424#
425#	${name}_flags	n	Arguments to call ${command} with.
426#				NOTE:	$flags from the parent environment
427#					can be used to override this.
428#
429#	${name}_nice	n	Nice level to run ${command} at.
430#
431#	${name}_user	n	User to run ${command} as, using su(1) if not
432#				using ${name}_chroot.
433#				Requires /usr to be mounted.
434#
435#	${name}_group	n	Group to run chrooted ${command} as.
436#				Requires /usr to be mounted.
437#
438#	${name}_groups	n	Comma separated list of supplementary groups
439#				to run the chrooted ${command} with.
440#				Requires /usr to be mounted.
441#
442#	${rc_arg}_cmd	n	If set, use this as the method when invoked;
443#				Otherwise, use default command (see below)
444#
445#	${rc_arg}_precmd n	If set, run just before performing the
446#				${rc_arg}_cmd method in the default
447#				operation (i.e, after checking for required
448#				bits and process (non)existence).
449#				If this completes with a non-zero exit code,
450#				don't run ${rc_arg}_cmd.
451#
452#	${rc_arg}_postcmd n	If set, run just after performing the
453#				${rc_arg}_cmd method, if that method
454#				returned a zero exit code.
455#
456#	required_dirs	n	If set, check for the existence of the given
457#				directories before running a (re)start command.
458#
459#	required_files	n	If set, check for the readability of the given
460#				files before running a (re)start command.
461#
462#	required_modules n	If set, ensure the given kernel modules are
463#				loaded before running a (re)start command.
464#				The check and possible loads are actually
465#				done after start_precmd so that the modules
466#				aren't loaded in vain, should the precmd
467#				return a non-zero status to indicate a error.
468#				If a word in the list looks like "foo:bar",
469#				"foo" is the KLD file name and "bar" is the
470#				module name.  If a word looks like "foo~bar",
471#				"foo" is the KLD file name and "bar" is a
472#				egrep(1) pattern matching the module name.
473#				Otherwise the module name is assumed to be
474#				the same as the KLD file name, which is most
475#				common.  See load_kld().
476#
477#	required_vars	n	If set, perform checkyesno on each of the
478#				listed variables before running the default
479#				(re)start command.
480#
481#	Default behaviour for a given argument, if no override method is
482#	provided:
483#
484#	Argument	Default behaviour
485#	--------	-----------------
486#	start		if !running && checkyesno ${rcvar}
487#				${command}
488#
489#	stop		if ${pidfile}
490#				rc_pid=$(check_pidfile $pidfile $command)
491#			else
492#				rc_pid=$(check_process $command)
493#			kill $sig_stop $rc_pid
494#			wait_for_pids $rc_pid
495#			($sig_stop defaults to TERM.)
496#
497#	reload		Similar to stop, except use $sig_reload instead,
498#			and doesn't wait_for_pids.
499#			$sig_reload defaults to HUP.
500#			Note that `reload' isn't provided by default,
501#			it should be enabled via $extra_commands.
502#
503#	restart		Run `stop' then `start'.
504#
505#	status		Show if ${command} is running, etc.
506#
507#	poll		Wait for ${command} to exit.
508#
509#	rcvar		Display what rc.conf variable is used (if any).
510#
511#	Variables available to methods, and after run_rc_command() has
512#	completed:
513#
514#	Variable	Purpose
515#	--------	-------
516#	rc_arg		Argument to command, after fast/force/one processing
517#			performed
518#
519#	rc_flags	Flags to start the default command with.
520#			Defaults to ${name}_flags, unless overridden
521#			by $flags from the environment.
522#			This variable may be changed by the precmd method.
523#
524#	rc_pid		PID of command (if appropriate)
525#
526#	rc_fast		Not empty if "fast" was provided (q.v.)
527#
528#	rc_force	Not empty if "force" was provided (q.v.)
529#
530#	rc_quiet	Not empty if "quiet" was provided
531#
532#
533run_rc_command()
534{
535	_return=0
536	rc_arg=$1
537	if [ -z "$name" ]; then
538		err 3 'run_rc_command: $name is not set.'
539	fi
540
541	# Don't repeat the first argument when passing additional command-
542	# line arguments to the command subroutines.
543	#
544	shift 1
545	rc_extra_args="$*"
546
547	_rc_prefix=
548	case "$rc_arg" in
549	fast*)				# "fast" prefix; don't check pid
550		rc_arg=${rc_arg#fast}
551		rc_fast=yes
552		rc_quiet=yes
553		;;
554	force*)				# "force prefix; always run
555		rc_force=yes
556		_rc_prefix=force
557		rc_arg=${rc_arg#${_rc_prefix}}
558		if [ -n "${rcvar}" ]; then
559			eval ${rcvar}=YES
560		fi
561		;;
562	one*)				# "one" prefix; set ${rcvar}=yes
563		_rc_prefix=one
564		rc_arg=${rc_arg#${_rc_prefix}}
565		if [ -n "${rcvar}" ]; then
566			eval ${rcvar}=YES
567		fi
568		;;
569	quiet*)				# "quiet" prefix; omit some messages
570		_rc_prefix=quiet
571		rc_arg=${rc_arg#${_rc_prefix}}
572		rc_quiet=yes
573		;;
574	esac
575
576	eval _override_command=\$${name}_program
577	command=${command:+${_override_command:-$command}}
578
579	_keywords="start stop restart rcvar $extra_commands"
580	rc_pid=
581	_pidcmd=
582	_procname=${procname:-${command}}
583
584					# setup pid check command
585	if [ -n "$_procname" ]; then
586		if [ -n "$pidfile" ]; then
587			_pidcmd='rc_pid=$(check_pidfile '"$pidfile $_procname $command_interpreter"')'
588		else
589			_pidcmd='rc_pid=$(check_process '"$_procname $command_interpreter"')'
590		fi
591		if [ -n "$_pidcmd" ]; then
592			_keywords="${_keywords} status poll"
593		fi
594	fi
595
596	if [ -z "$rc_arg" ]; then
597		rc_usage $_keywords
598	fi
599
600	if [ -n "$flags" ]; then	# allow override from environment
601		rc_flags=$flags
602	else
603		eval rc_flags=\$${name}_flags
604	fi
605	eval _chdir=\$${name}_chdir	_chroot=\$${name}_chroot \
606	    _nice=\$${name}_nice	_user=\$${name}_user \
607	    _group=\$${name}_group	_groups=\$${name}_groups
608
609	if [ -n "$_user" ]; then	# unset $_user if running as that user
610		if [ "$_user" = "$(eval $IDCMD)" ]; then
611			unset _user
612		fi
613	fi
614
615	eval $_pidcmd			# determine the pid if necessary
616
617	for _elem in $_keywords; do
618		if [ "$_elem" != "$rc_arg" ]; then
619			continue
620		fi
621					# if ${rcvar} is set, and $1 is not
622					# "rcvar", then run
623					#	checkyesno ${rcvar}
624					# and return if that failed
625					#
626		if [ -n "${rcvar}" -a "$rc_arg" != "rcvar" ]; then
627			if ! checkyesno ${rcvar}; then
628				if [ -n "${rc_quiet}" ]; then
629					return 0
630				fi
631				echo -n "Cannot '${rc_arg}' $name. Set ${rcvar} to "
632				echo -n "YES in /etc/rc.conf or use 'one${rc_arg}' "
633				echo "instead of '${rc_arg}'."
634				return 0
635			fi
636		fi
637
638					# if there's a custom ${XXX_cmd},
639					# run that instead of the default
640					#
641		eval _cmd=\$${rc_arg}_cmd \
642		     _precmd=\$${rc_arg}_precmd \
643		     _postcmd=\$${rc_arg}_postcmd
644
645		if [ -n "$_cmd" ]; then
646			_run_rc_precmd || return 1
647			_run_rc_doit "$_cmd $rc_extra_args" || return 1
648			_run_rc_postcmd
649			return $_return
650		fi
651
652		case "$rc_arg" in	# default operations...
653
654		status)
655			_run_rc_precmd || return 1
656			if [ -n "$rc_pid" ]; then
657				echo "${name} is running as pid $rc_pid."
658			else
659				echo "${name} is not running."
660				return 1
661			fi
662			_run_rc_postcmd
663			;;
664
665		start)
666			if [ -z "$rc_fast" -a -n "$rc_pid" ]; then
667				echo 1>&2 "${name} already running? (pid=$rc_pid)."
668				return 1
669			fi
670
671			if [ ! -x ${_chroot}${_chroot:+"/"}${command} ]; then
672				warn "run_rc_command: cannot run $command"
673				return 1
674			fi
675
676			_run_rc_precmd || return 1
677
678					# setup the full command to run
679					#
680			echo "Starting ${name}."
681			if [ -n "$_chroot" ]; then
682				_doit="\
683${_nice:+nice -n $_nice }\
684chroot ${_user:+-u $_user }${_group:+-g $_group }${_groups:+-G $_groups }\
685$_chroot $command $rc_flags $command_args"
686			else
687				_doit="\
688${_chdir:+cd $_chdir && }\
689$command $rc_flags $command_args"
690				if [ -n "$_user" ]; then
691				    _doit="su -m $_user -c 'sh -c \"$_doit\"'"
692				fi
693				if [ -n "$_nice" ]; then
694					if [ -z "$_user" ]; then
695						_doit="sh -c \"$_doit\""
696					fi	
697					_doit="nice -n $_nice $_doit"
698				fi
699			fi
700
701					# run the full command
702					#
703			_run_rc_doit "$_doit" || return 1
704
705					# finally, run postcmd
706					#
707			_run_rc_postcmd
708			;;
709
710		stop)
711			if [ -z "$rc_pid" ]; then
712				[ -n "$rc_fast" ] && return 0
713				_run_rc_notrunning
714				return 1
715			fi
716
717			_run_rc_precmd || return 1
718
719					# send the signal to stop
720					#
721			echo "Stopping ${name}."
722			_doit=$(_run_rc_killcmd "${sig_stop:-TERM}")
723			_run_rc_doit "$_doit" || return 1
724
725					# wait for the command to exit,
726					# and run postcmd.
727			wait_for_pids $rc_pid
728
729			_run_rc_postcmd
730			;;
731
732		reload)
733			if [ -z "$rc_pid" ]; then
734				_run_rc_notrunning
735				return 1
736			fi
737
738			_run_rc_precmd || return 1
739
740			_doit=$(_run_rc_killcmd "${sig_reload:-HUP}")
741			_run_rc_doit "$_doit" || return 1
742
743			_run_rc_postcmd
744			;;
745
746		restart)
747					# prevent restart being called more
748					# than once by any given script
749					#
750			if ${_rc_restart_done:-false}; then
751				return 0
752			fi
753			_rc_restart_done=true
754
755			_run_rc_precmd || return 1
756
757			# run those in a subshell to keep global variables
758			( run_rc_command ${_rc_prefix}stop $rc_extra_args )
759			( run_rc_command ${_rc_prefix}start $rc_extra_args )
760			_return=$?
761			[ $_return -ne 0 ] && [ -z "$rc_force" ] && return 1
762
763			_run_rc_postcmd
764			;;
765
766		poll)
767			_run_rc_precmd || return 1
768			if [ -n "$rc_pid" ]; then
769				wait_for_pids $rc_pid
770			fi
771			_run_rc_postcmd
772			;;
773
774		rcvar)
775			echo "# $name"
776			if [ -n "$rcvar" ]; then
777				if checkyesno ${rcvar}; then
778					echo "${rcvar}=YES"
779				else
780					echo "${rcvar}=NO"
781				fi
782			fi
783			;;
784
785		*)
786			rc_usage $_keywords
787			;;
788
789		esac
790		return $_return
791	done
792
793	echo 1>&2 "$0: unknown directive '$rc_arg'."
794	rc_usage $_keywords
795	# not reached
796}
797
798#
799# Helper functions for run_rc_command: common code.
800# They use such global variables besides the exported rc_* ones:
801#
802#	name	       R/W
803#	------------------
804#	_precmd		R
805#	_postcmd	R
806#	_return		W
807#
808_run_rc_precmd()
809{
810	check_required_before "$rc_arg" || return 1
811
812	if [ -n "$_precmd" ]; then
813		debug "run_rc_command: ${rc_arg}_precmd: $_precmd $rc_extra_args"
814		eval "$_precmd $rc_extra_args"
815		_return=$?
816
817		# If precmd failed and force isn't set, request exit.
818		if [ $_return -ne 0 ] && [ -z "$rc_force" ]; then
819			return 1
820		fi
821	fi
822
823	check_required_after "$rc_arg" || return 1
824
825	return 0
826}
827
828_run_rc_postcmd()
829{
830	if [ -n "$_postcmd" ]; then
831		debug "run_rc_command: ${rc_arg}_postcmd: $_postcmd $rc_extra_args"
832		eval "$_postcmd $rc_extra_args"
833		_return=$?
834	fi
835	return 0
836}
837
838_run_rc_doit()
839{
840	debug "run_rc_command: doit: $*"
841	eval "$@"
842	_return=$?
843
844	# If command failed and force isn't set, request exit.
845	if [ $_return -ne 0 ] && [ -z "$rc_force" ]; then
846		return 1
847	fi
848
849	return 0
850}
851
852_run_rc_notrunning()
853{
854	local _pidmsg
855
856	if [ -n "$pidfile" ]; then
857		_pidmsg=" (check $pidfile)."
858	else
859		_pidmsg=
860	fi
861	echo 1>&2 "${name} not running?${_pidmsg}"
862}
863
864_run_rc_killcmd()
865{
866	local _cmd
867
868	_cmd="kill -$1 $rc_pid"
869	if [ -n "$_user" ]; then
870		_cmd="su -m ${_user} -c 'sh -c \"${_cmd}\"'"
871	fi
872	echo "$_cmd"
873}
874
875#
876# run_rc_script file arg
877#	Start the script `file' with `arg', and correctly handle the
878#	return value from the script.  If `file' ends with `.sh', it's
879#	sourced into the current environment.  If `file' appears to be
880#	a backup or scratch file, ignore it.  Otherwise if it's
881#	executable run as a child process.
882#
883run_rc_script()
884{
885	_file=$1
886	_arg=$2
887	if [ -z "$_file" -o -z "$_arg" ]; then
888		err 3 'USAGE: run_rc_script file arg'
889	fi
890
891	unset	name command command_args command_interpreter \
892		extra_commands pidfile procname \
893		rcvar required_dirs required_files required_vars
894	eval unset ${_arg}_cmd ${_arg}_precmd ${_arg}_postcmd
895
896	case "$_file" in
897	/etc/rc.d/*.sh)			# run in current shell
898		set $_arg; . $_file
899		;;
900	*[~#]|*.OLD|*.bak|*.orig|*,v)	# scratch file; skip
901		warn "Ignoring scratch file $_file"
902		;;
903	*)				# run in subshell
904		if [ -x $_file ]; then
905			if [ -n "$rc_fast_and_loose" ]; then
906				set $_arg; . $_file
907			else
908				( trap "echo Script $_file interrupted; kill -QUIT $$" 3
909				  trap "echo Script $_file interrupted; exit 1" 2
910				  set $_arg; . $_file )
911			fi
912		fi
913		;;
914	esac
915}
916
917#
918# load_rc_config name
919#	Source in the configuration file for a given name.
920#
921load_rc_config()
922{
923	_name=$1
924	if [ -z "$_name" ]; then
925		err 3 'USAGE: load_rc_config name'
926	fi
927
928	if ${_rc_conf_loaded:-false}; then
929		:
930	else
931		if [ -r /etc/defaults/rc.conf ]; then
932			debug "Sourcing /etc/defaults/rc.conf"
933			. /etc/defaults/rc.conf
934			source_rc_confs
935		elif [ -r /etc/rc.conf ]; then
936			debug "Sourcing /etc/rc.conf (/etc/defaults/rc.conf doesn't exist)."
937			. /etc/rc.conf
938		fi
939		_rc_conf_loaded=true
940	fi
941	if [ -f /etc/rc.conf.d/"$_name" ]; then
942		debug "Sourcing /etc/rc.conf.d/${_name}"
943		. /etc/rc.conf.d/"$_name"
944	fi
945
946	# Old variable names support
947	#
948	[ -n "$enable_quotas" ] && quota_enable="$enable_quotas"
949}
950  
951#
952# load_rc_config_var name var
953#	Read the rc.conf(5) var for name and set in the
954#	current shell, using load_rc_config in a subshell to prevent
955#	unwanted side effects from other variable assignments.
956#
957load_rc_config_var()
958{
959	if [ $# -ne 2 ]; then
960		err 3 'USAGE: load_rc_config_var name var'
961	fi
962	eval $(eval '(
963		load_rc_config '$1' >/dev/null;
964                if [ -n "${'$2'}" -o "${'$2'-UNSET}" != "UNSET" ]; then
965			echo '$2'=\'\''${'$2'}\'\'';
966		fi
967	)' )
968}
969
970#
971# rc_usage commands
972#	Print a usage string for $0, with `commands' being a list of
973#	valid commands.
974#
975rc_usage()
976{
977	echo -n 1>&2 "Usage: $0 [fast|force|one]("
978
979	_sep=
980	for _elem; do
981		echo -n 1>&2 "$_sep$_elem"
982		_sep="|"
983	done
984	echo 1>&2 ")"
985	exit 1
986}
987
988#
989# err exitval message
990#	Display message to stderr and log to the syslog, and exit with exitval.
991#
992err()
993{
994	exitval=$1
995	shift
996
997	if [ -x /usr/bin/logger ]; then
998		logger "$0: ERROR: $*"
999	fi
1000	echo 1>&2 "$0: ERROR: $*"
1001	exit $exitval
1002}
1003
1004#
1005# warn message
1006#	Display message to stderr and log to the syslog.
1007#
1008warn()
1009{
1010	if [ -x /usr/bin/logger ]; then
1011		logger "$0: WARNING: $*"
1012	fi
1013	echo 1>&2 "$0: WARNING: $*"
1014}
1015
1016#
1017# info message
1018#	Display informational message to stdout and log to syslog.
1019#
1020info()
1021{
1022	case ${rc_info} in
1023	[Yy][Ee][Ss]|[Tt][Rr][Uu][Ee]|[Oo][Nn]|1)
1024		if [ -x /usr/bin/logger ]; then
1025			logger "$0: INFO: $*"
1026		fi
1027		echo "$0: INFO: $*"
1028		;;
1029	esac
1030}
1031
1032#
1033# debug message
1034#	If debugging is enabled in rc.conf output message to stderr.
1035#	BEWARE that you don't call any subroutine that itself calls this
1036#	function.
1037#
1038debug()
1039{
1040	case ${rc_debug} in
1041	[Yy][Ee][Ss]|[Tt][Rr][Uu][Ee]|[Oo][Nn]|1)
1042		if [ -x /usr/bin/logger ]; then
1043			logger "$0: DEBUG: $*"
1044		fi
1045		echo 1>&2 "$0: DEBUG: $*"
1046		;;
1047	esac
1048}
1049
1050#
1051# backup_file action file cur backup
1052#	Make a backup copy of `file' into `cur', and save the previous
1053#	version of `cur' as `backup' or use rcs for archiving.
1054#
1055#	This routine checks the value of the backup_uses_rcs variable,
1056#	which can be either YES or NO.
1057#
1058#	The `action' keyword can be one of the following:
1059#
1060#	add		`file' is now being backed up (and is possibly
1061#			being reentered into the backups system).  `cur'
1062#			is created and RCS files, if necessary, are
1063#			created as well.
1064#
1065#	update		`file' has changed and needs to be backed up.
1066#			If `cur' exists, it is copied to to `back' or
1067#			checked into RCS (if the repository file is old),
1068#			and then `file' is copied to `cur'.  Another RCS
1069#			check in done here if RCS is being used.
1070#
1071#	remove		`file' is no longer being tracked by the backups
1072#			system.  If RCS is not being used, `cur' is moved
1073#			to `back', otherwise an empty file is checked in,
1074#			and then `cur' is removed.
1075#
1076#
1077backup_file()
1078{
1079	_action=$1
1080	_file=$2
1081	_cur=$3
1082	_back=$4
1083
1084	if checkyesno backup_uses_rcs; then
1085		_msg0="backup archive"
1086		_msg1="update"
1087
1088		# ensure that history file is not locked
1089		if [ -f $_cur,v ]; then
1090			rcs -q -u -U -M $_cur
1091		fi
1092
1093		# ensure after switching to rcs that the
1094		# current backup is not lost
1095		if [ -f $_cur ]; then
1096			# no archive, or current newer than archive
1097			if [ ! -f $_cur,v -o $_cur -nt $_cur,v ]; then
1098				ci -q -f -u -t-"$_msg0" -m"$_msg1" $_cur
1099				rcs -q -kb -U $_cur
1100				co -q -f -u $_cur
1101			fi
1102		fi
1103
1104		case $_action in
1105		add|update)
1106			cp -p $_file $_cur
1107			ci -q -f -u -t-"$_msg0" -m"$_msg1" $_cur
1108			rcs -q -kb -U $_cur
1109			co -q -f -u $_cur
1110			chown root:wheel $_cur $_cur,v
1111			;;
1112		remove)
1113			cp /dev/null $_cur
1114			ci -q -f -u -t-"$_msg0" -m"$_msg1" $_cur
1115			rcs -q -kb -U $_cur
1116			chown root:wheel $_cur $_cur,v
1117			rm $_cur
1118			;;
1119		esac
1120	else
1121		case $_action in
1122		add|update)
1123			if [ -f $_cur ]; then
1124				cp -p $_cur $_back
1125			fi
1126			cp -p $_file $_cur
1127			chown root:wheel $_cur
1128			;;
1129		remove)
1130			mv -f $_cur $_back
1131			;;
1132		esac
1133	fi
1134}
1135
1136# make_symlink src link
1137#	Make a symbolic link 'link' to src from basedir. If the
1138#	directory in which link is to be created does not exist
1139#	a warning will be displayed and an error will be returned.
1140#	Returns 0 on sucess, 1 otherwise.
1141#
1142make_symlink()
1143{
1144	local src link linkdir _me
1145	src="$1"
1146	link="$2"
1147	linkdir="`dirname $link`"
1148	_me="make_symlink()"
1149
1150	if [ -z "$src" -o -z "$link" ]; then
1151		warn "$_me: requires two arguments."
1152		return 1
1153	fi
1154	if [ ! -d "$linkdir" ]; then
1155		warn "$_me: the directory $linkdir does not exist."
1156		return 1
1157	fi
1158	if ! ln -sf $src $link; then
1159		warn "$_me: unable to make a symbolic link from $link to $src"
1160		return 1
1161	fi
1162	return 0
1163}
1164
1165# devfs_rulesets_from_file file
1166#	Reads a set of devfs commands from file, and creates
1167#	the specified rulesets with their rules. Returns non-zero
1168#	if there was an error.
1169#
1170devfs_rulesets_from_file()
1171{
1172	local file _err _me
1173	file="$1"
1174	_me="devfs_rulesets_from_file"
1175	_err=0
1176
1177	if [ -z "$file" ]; then
1178		warn "$_me: you must specify a file"
1179		return 1
1180	fi
1181	if [ ! -e "$file" ]; then
1182		debug "$_me: no such file ($file)"
1183		return 0
1184	fi
1185	debug "reading rulesets from file ($file)"
1186	{ while read line
1187	do
1188		case $line in
1189		\#*)
1190			continue
1191			;;
1192		\[*\]*)
1193			rulenum=`expr "$line" : "\[.*=\([0-9]*\)\]"`
1194			if [ -z "$rulenum" ]; then
1195				warn "$_me: cannot extract rule number ($line)"
1196				_err=1
1197				break
1198			fi
1199			rulename=`expr "$line" : "\[\(.*\)=[0-9]*\]"`
1200			if [ -z "$rulename" ]; then
1201				warn "$_me: cannot extract rule name ($line)"
1202				_err=1
1203				break;
1204			fi
1205			eval $rulename=\$rulenum
1206			debug "found ruleset: $rulename=$rulenum"
1207			if ! /sbin/devfs rule -s $rulenum delset; then
1208				_err=1
1209				break
1210			fi
1211			;;
1212		*)
1213			rulecmd="${line%%"\#*"}"
1214			# evaluate the command incase it includes
1215			# other rules
1216			if [ -n "$rulecmd" ]; then
1217				debug "adding rule ($rulecmd)"
1218				if ! eval /sbin/devfs rule -s $rulenum $rulecmd
1219				then
1220					_err=1
1221					break
1222				fi
1223			fi
1224			;;
1225		esac
1226		if [ $_err -ne 0 ]; then
1227			debug "error in $_me"
1228			break
1229		fi
1230	done } < $file
1231	return $_err
1232}
1233
1234# devfs_init_rulesets
1235#	Initializes rulesets from configuration files. Returns
1236#	non-zero if there was an error.
1237#
1238devfs_init_rulesets()
1239{
1240	local file _me
1241	_me="devfs_init_rulesets"
1242
1243	# Go through this only once
1244	if [ -n "$devfs_rulesets_init" ]; then
1245		debug "$_me: devfs rulesets already initialized"
1246		return
1247	fi
1248	for file in $devfs_rulesets; do
1249		devfs_rulesets_from_file $file || return 1
1250	done
1251	devfs_rulesets_init=1
1252	debug "$_me: devfs rulesets initialized"
1253	return 0
1254}
1255
1256# devfs_set_ruleset ruleset [dir]
1257#	Sets the default ruleset of dir to ruleset. The ruleset argument
1258#	must be a ruleset name as specified in devfs.rules(5) file.
1259#	Returns non-zero if it could not set it successfully.
1260#
1261devfs_set_ruleset()
1262{
1263	local devdir rs _me
1264	[ -n "$1" ] && eval rs=\$$1 || rs=
1265	[ -n "$2" ] && devdir="-m "$2"" || devdir=
1266	_me="devfs_set_ruleset"
1267
1268	if [ -z "$rs" ]; then
1269		warn "$_me: you must specify a ruleset number"
1270		return 1
1271	fi
1272	debug "$_me: setting ruleset ($rs) on mount-point (${devdir#-m })"
1273	if ! /sbin/devfs $devdir ruleset $rs; then
1274		warn "$_me: unable to set ruleset $rs to ${devdir#-m }"
1275		return 1
1276	fi
1277	return 0
1278}
1279
1280# devfs_apply_ruleset ruleset [dir]
1281#	Apply ruleset number $ruleset to the devfs mountpoint $dir.
1282#	The ruleset argument must be a ruleset name as specified
1283#	in a devfs.rules(5) file.  Returns 0 on success or non-zero
1284#	if it could not apply the ruleset.
1285#
1286devfs_apply_ruleset()
1287{
1288	local devdir rs _me
1289	[ -n "$1" ] && eval rs=\$$1 || rs=
1290	[ -n "$2" ] && devdir="-m "$2"" || devdir=
1291	_me="devfs_apply_ruleset"
1292
1293	if [ -z "$rs" ]; then
1294		warn "$_me: you must specify a ruleset"
1295		return 1
1296	fi
1297	debug "$_me: applying ruleset ($rs) to mount-point (${devdir#-m })"
1298	if ! /sbin/devfs $devdir rule -s $rs applyset; then
1299		warn "$_me: unable to apply ruleset $rs to ${devdir#-m }"
1300		return 1
1301	fi
1302	return 0
1303}
1304
1305# devfs_domount dir [ruleset]
1306#	Mount devfs on dir. If ruleset is specified it is set
1307#	on the mount-point. It must also be a ruleset name as specified
1308#	in a devfs.rules(5) file. Returns 0 on success.
1309#
1310devfs_domount()
1311{
1312	local devdir rs _me
1313	devdir="$1"
1314	[ -n "$2" ] && rs=$2 || rs=
1315	_me="devfs_domount()"
1316
1317	if [ -z "$devdir" ]; then
1318		warn "$_me: you must specify a mount-point"
1319		return 1
1320	fi
1321	debug "$_me: mount-point is ($devdir), ruleset is ($rs)"
1322	if ! mount -t devfs dev "$devdir"; then
1323		warn "$_me: Unable to mount devfs on $devdir"
1324		return 1
1325	fi
1326	if [ -n "$rs" ]; then
1327		devfs_init_rulesets
1328		devfs_set_ruleset $rs $devdir
1329		devfs -m $devdir rule applyset
1330	fi
1331	return 0
1332}
1333
1334# devfs_mount_jail dir [ruleset]
1335#	Mounts a devfs file system appropriate for jails
1336#	on the directory dir. If ruleset is specified, the ruleset
1337#	it names will be used instead.  If present, ruleset must
1338#	be the name of a ruleset as defined in a devfs.rules(5) file.
1339#	This function returns non-zero if an error occurs.
1340#
1341devfs_mount_jail()
1342{
1343	local jdev rs _me
1344	jdev="$1"
1345	[ -n "$2" ] && rs=$2 || rs="devfsrules_jail"
1346	_me="devfs_mount_jail"
1347
1348	devfs_init_rulesets
1349	if ! devfs_domount "$jdev" $rs; then
1350		warn "$_me: devfs was not mounted on $jdev"
1351		return 1
1352	fi
1353	return 0
1354}
1355
1356# Provide a function for normalizing the mounting of memory
1357# filesystems.  This should allow the rest of the code here to remain
1358# as close as possible between 5-current and 4-stable.
1359#   $1 = size
1360#   $2 = mount point
1361#   $3 = (optional) extra mdmfs flags
1362mount_md()
1363{
1364	if [ -n "$3" ]; then
1365		flags="$3"
1366	fi
1367	/sbin/mdmfs $flags -s $1 md $2
1368}
1369
1370# Code common to scripts that need to load a kernel module
1371# if it isn't in the kernel yet. Syntax:
1372#   load_kld [-e regex] [-m module] file
1373# where -e or -m chooses the way to check if the module
1374# is already loaded:
1375#   regex is egrep'd in the output from `kldstat -v',
1376#   module is passed to `kldstat -m'.
1377# The default way is as though `-m file' were specified.
1378load_kld()
1379{
1380	local _loaded _mod _opt _re
1381
1382	while getopts "e:m:" _opt; do
1383		case "$_opt" in
1384		e) _re="$OPTARG" ;;
1385		m) _mod="$OPTARG" ;;
1386		*) err 3 'USAGE: load_kld [-e regex] [-m module] file' ;;
1387		esac
1388	done
1389	shift $(($OPTIND - 1))
1390	if [ $# -ne 1 ]; then
1391		err 3 'USAGE: load_kld [-e regex] [-m module] file'
1392	fi
1393	_mod=${_mod:-$1}
1394	_loaded=false
1395	if [ -n "$_re" ]; then
1396		if kldstat -v | egrep -q -e "$_re"; then
1397			_loaded=true
1398		fi
1399	else
1400		if kldstat -q -m "$_mod"; then
1401			_loaded=true
1402		fi
1403	fi
1404	if ! $_loaded; then
1405		if ! kldload "$1"; then
1406			warn "Unable to load kernel module $1"
1407			return 1
1408		else
1409			info "$1 kernel module loaded."
1410		fi
1411	else
1412		debug "load_kld: $1 kernel module already loaded."
1413	fi
1414	return 0
1415}
1416
1417# ltr str src dst
1418#	Change every $src in $str to $dst.
1419#	Useful when /usr is not yet mounted and we cannot use tr(1), sed(1) nor
1420#	awk(1).
1421ltr()
1422{
1423	local _str _src _dst _out _com
1424	_str=$1
1425	_src=$2
1426	_dst=$3
1427	_out=""
1428
1429	IFS=${_src}
1430	for _com in ${_str}; do
1431		if [ -z "${_out}" ]; then
1432			_out="${_com}"
1433		else
1434			_out="${_out}${_dst}${_com}"
1435		fi
1436	done
1437	echo "${_out}"
1438}
1439
1440# Creates a list of providers for GELI encryption.
1441geli_make_list()
1442{
1443	local devices devices2
1444	local provider mountpoint type options rest
1445
1446	# Create list of GELI providers from fstab.
1447	while read provider mountpoint type options rest ; do
1448		case ":${options}" in
1449		:*noauto*)
1450			noauto=yes
1451			;;
1452		*)
1453			noauto=no
1454			;;
1455		esac
1456
1457		case ":${provider}" in
1458		:#*)
1459			continue
1460			;;
1461		*.eli)
1462			# Skip swap devices.
1463			if [ "${type}" = "swap" -o "${options}" = "sw" -o "${noauto}" = "yes" ]; then
1464				continue
1465			fi
1466			devices="${devices} ${provider}"
1467			;;
1468		esac
1469	done < /etc/fstab
1470
1471	# Append providers from geli_devices.
1472	devices="${devices} ${geli_devices}"
1473
1474	for provider in ${devices}; do
1475		provider=${provider%.eli}
1476		provider=${provider#/dev/}
1477		devices2="${devices2} ${provider}"
1478	done
1479
1480	echo ${devices2}
1481}
1482
1483# Find scripts in local_startup directories that use the old syntax
1484#
1485find_local_scripts_old () {
1486	zlist=''
1487	slist=''
1488	for dir in ${local_startup}; do
1489		if [ -d "${dir}" ]; then
1490			for file in ${dir}/[0-9]*.sh; do
1491				grep '^# PROVIDE:' $file >/dev/null 2>&1 &&
1492				    continue
1493				zlist="$zlist $file"
1494			done
1495			for file in ${dir}/[^0-9]*.sh; do
1496				grep '^# PROVIDE:' $file >/dev/null 2>&1 &&
1497				    continue
1498				slist="$slist $file"
1499			done
1500		fi
1501	done
1502}
1503
1504find_local_scripts_new () {
1505	local_rc=''
1506	for dir in ${local_startup}; do
1507		if [ -d "${dir}" ]; then
1508			for file in `grep -l '^# PROVIDE:' ${dir}/* 2>/dev/null`; do
1509				case "$file" in
1510				*.sample) ;;
1511				*)	if [ -x "$file" ]; then
1512						local_rc="${local_rc} ${file}"
1513					fi
1514					;;
1515				esac
1516			done
1517		fi
1518	done
1519}
1520
1521# check_required_{before|after} command
1522#	Check for things required by the command before and after its precmd,
1523#	respectively.  The two separate functions are needed because some
1524#	conditions should prevent precmd from being run while other things
1525#	depend on precmd having already been run.
1526#
1527check_required_before()
1528{
1529	local _f
1530
1531	case "$1" in
1532	start)
1533		for _f in $required_vars; do
1534			if ! checkyesno $_f; then
1535				warn "\$${_f} is not enabled."
1536				if [ -z "$rc_force" ]; then
1537					return 1
1538				fi
1539			fi
1540		done
1541
1542		for _f in $required_dirs; do
1543			if [ ! -d "${_f}/." ]; then
1544				warn "${_f} is not a directory."
1545				if [ -z "$rc_force" ]; then
1546					return 1
1547				fi
1548			fi
1549		done
1550
1551		for _f in $required_files; do
1552			if [ ! -r "${_f}" ]; then
1553				warn "${_f} is not readable."
1554				if [ -z "$rc_force" ]; then
1555					return 1
1556				fi
1557			fi
1558		done
1559		;;
1560	esac
1561
1562	return 0
1563}
1564
1565check_required_after()
1566{
1567	local _f _args
1568
1569	case "$1" in
1570	start)
1571		for _f in $required_modules; do
1572			case "${_f}" in
1573				*~*)	_args="-e ${_f#*~} ${_f%%~*}" ;;
1574				*:*)	_args="-m ${_f#*:} ${_f%%:*}" ;;
1575				*)	_args="${_f}" ;;
1576			esac
1577			if ! load_kld ${_args}; then
1578				if [ -z "$rc_force" ]; then
1579					return 1
1580				fi
1581			fi
1582		done
1583		;;
1584	esac
1585
1586	return 0
1587}
1588
1589fi
1590
1591_rc_subr_loaded=:
1592